using Plots
using Zygote
using Statistics
using LinearAlgebra

include("readclassjson.jl")

data = readclassjson("opt_data.json")
X_train = data["X_train"]
y_train = data["y_train"]

n, d = size(X_train)
lambda = 1e-2

function f(theta)
    return mean(log(1 + exp(-y_train[i] * dot(X_train[i,:],theta))) for i in 1:n) + lambda * sum(abs2.(theta))
end

function gradient_method(f, kmax)
    # TODO: Implement gradient method
end

thetas = gradient_method(f, 35)
grad_norms = [norm(gradient(f, theta)) for theta in thetas]

plot(1:36, f.(thetas), xlabel="Iteration", ylabel="Function value", legend=false)
savefig("opt_function.pdf")
plot(1:36, grad_norms, xlabel="Iteration", ylabel="Gradient norm", legend=false)
savefig("opt_gradient.pdf")
