using LinearAlgebra
using Plots

include("writeclassjson.jl")

data = readclassjson("pca_data.json")

X = data["X"]
demographics = data["demographics"]

function pca(X, r)
    U, S, V = svd(X)
    return V[:,1:r]
end

function plot_pca(points, labels)
    scatter(xlabel="Principal component 1", ylabel="Principal component 2")
    for label in unique(labels)
        xs = [points[i,1] for i in 1:size(points,1) if labels[i] == label]
        ys = [points[i,2] for i in 1:size(points,1) if labels[i] == label]
        scatter!(xs, ys, label=label)
    end
    savefig("pca_plot.pdf")
end


# TODO: Compress data to 2 dimensions
# TODO: Plot compressed data
